;Texture "edhu09M.jpg" by opsie.free.fr

;Lightmap Demo
;
;Requests Cinema 4D R10(full or demo)
;
;This demo shows how to apply a lightmap on a second UVW-set.
;The lightmap and second UVW-set was created in Cinema 4D using Texture Baker. 

;How to do:
;
;1. Mark that object you want to create a lightmap for.
;2. Clone its UVW-tag, it will be overwritten otherwise.
;3. Use command Render->Bake Texture to create a "Bake Texture" tag.
;4. Mark this tag and set a texture name. Choose tab strip "Options" and set option "Illumination". 
;   Set "Angle" for "Optimal Mapping".
;5. Use "Bake" button to create lightmap texture.
;6. Create a new material using this texture with mix "multiply" and apply it to the object
;7. Set option "Mix Textures" in texture tag
;8. The first UVW-tag contains the automatically created UV-map, which an exclusive space for each polygon.
;   A texture refers always to the following UVW-tag, so your object texture should be located between both UVW-tags.
;	If there isn't any following UVW-tag, the first one will be used, therefore it works with just placing the lightmap
;   at the last position. With this technique there is no need to arrange your UVW-tags, even if a new lightmap/mapping is rendered. 


Graphics3D 640,480,32,2
SetBuffer BackBuffer()


;Load File
mesh = LoadAnimMesh ("City.b3d")


;Create Camera As Child Of "cam" 
camera=CreateCamera(FindChild(mesh, "cam"))
CameraRange camera, 1, 60000


;Create Light
light=CreateLight()
RotateEntity light,70,20,45


time_old = MilliSecs()
While Not KeyHit(1)

;  Tweening
   time_new   = MilliSecs()
   time_diff# = (time_new - time_old) / 1000.0
   time_old   = time_new

;  Animation
   If KeyHit(57) Then
      start=1-start
      Animate mesh, start, 10
   EndIf

   UpdateWorld time_diff#
   RenderWorld

;  Frames Per Second
   fps_fpscnt% = fps_fpscnt% + 1      
   fps_new_sec% = MilliSecs()
   If (fps_new_sec% => fps_old_sec% + 1000) 
      fps_fps% = fps_fpscnt%
      fps_fpscnt% = 0
      fps_old_sec% = fps_new_sec% 
   EndIf
   Text 0,0, fps_fps%

   Text 0,12, "Animation <SPACE>"

   Flip 0

Wend
End