;VertexAlpha Demo
;
;This demo shows how to set alpha for vertices using WeightMaps

;When handling more layers of a transparent mesh like in this demo, it is very important that every polygon of each 
;layer matches exactly its counterpart on the other layers to avoid flickering. 

Graphics3D 640,480,32,2
SetBuffer BackBuffer()


;Create Camera
cam_base=CreatePivot()
cam_ctrl=CreatePivot(cam_base)

camera=CreateCamera(cam_ctrl)
CameraClsColor camera, 0, 0, 0
RotateEntity camera, 0,0,0
PositionEntity camera,0,5,-200
RotateEntity cam_base, 0, -30, 0
RotateEntity cam_ctrl, 20, 0, 0

;Load File
mesh = LoadAnimMesh ("vertexalpha.b3d")


;Create Light
light=CreateLight()
RotateEntity light,70,20,45


time_old = MilliSecs()
While Not KeyHit(1)

;  Tweening
   time_new   = MilliSecs()
   time_diff# = (time_new - time_old) / 1000.0
   time_old   = time_new


;  Camera Movement
   TurnEntity cam_base,0,(KeyDown(203)-KeyDown(205))*time_diff#*120,0
   TurnEntity cam_ctrl, (KeyDown(200)-KeyDown(208))*time_diff#*120,0,0
   MoveEntity camera, 0,0,(KeyDown(78)-KeyDown(74))*time_diff#*100


   UpdateWorld time_diff#
   RenderWorld

;  Frames Per Second
   fps_fpscnt% = fps_fpscnt% + 1      
   fps_new_sec% = MilliSecs()
   If (fps_new_sec% => fps_old_sec% + 1000) 
      fps_fps% = fps_fpscnt%
      fps_fpscnt% = 0
      fps_old_sec% = fps_new_sec% 
   EndIf
   Text 0,0, fps_fps%

   Text 0,12, "Rotation <ARROW> | Zoom <+/->"

   Flip 0

Wend
End